diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/include/libssh/libssh.h libssh-wfs/include/libssh/libssh.h
--- libssh-trunk/include/libssh/libssh.h	2009-07-18 11:02:19.000000000 -0400
+++ libssh-wfs/include/libssh/libssh.h	2009-07-07 22:35:57.000000000 -0400
@@ -41,6 +41,8 @@
 
 
 #define LIBSSH_VERSION "libssh-0.3-svn"
+// Until our additions get into the upstream repository
+#define WFS_MODIFIED_LIBSSH
 
 #ifdef __cplusplus
 extern "C" {
@@ -161,6 +163,8 @@
 /* log.c */
 void ssh_log(SSH_SESSION *session, int prioriry, char *format, ...);
 
+void ssh_cleanup_lock(void *arg);
+
 /* session.c */
 SSH_SESSION *ssh_new();
 void ssh_set_options(SSH_SESSION *session, SSH_OPTIONS *options);
@@ -173,7 +177,11 @@
 
 
 /* client.c */
-int ssh_connect(SSH_SESSION *session);
+typedef struct ssh_cleanup_frame {
+  void (*handler)(void *);
+  void *arg;
+} ssh_cleanup_frame;
+int ssh_connect(SSH_SESSION *session, struct ssh_cleanup_frame **frames);
 void ssh_disconnect(SSH_SESSION *session);
 int ssh_service_request(SSH_SESSION *session,char *service);
 char *ssh_get_issue_banner(SSH_SESSION *session);
@@ -207,6 +215,8 @@
 /* this one can be called by the client to see the hash of the public key before accepting it */
 int ssh_get_pubkey_hash(SSH_SESSION *session,unsigned char hash[MD5_DIGEST_LEN]);
 STRING *ssh_get_pubkey(SSH_SESSION *session);
+/* You should free the result */
+char *ssh_get_pubkey_base64(SSH_SESSION *session);
 
 /* in connect.c */
 int ssh_fd_poll(SSH_SESSION *session,int *write, int *except);
@@ -230,7 +240,7 @@
 
 CHANNEL *channel_new(SSH_SESSION *session);
 int channel_open_forward(CHANNEL *channel,char *remotehost, int remoteport, char *sourcehost, int localport);
-int channel_open_session(CHANNEL *channel);
+  int channel_open_session(CHANNEL *channel, ssh_cleanup_frame **frames);
 void channel_free(CHANNEL *channel);
 int channel_request_pty(CHANNEL *channel);
 int channel_request_pty_size(CHANNEL *channel, char *term,int cols, int rows);
@@ -243,7 +253,9 @@
 int channel_write(CHANNEL *channel,void *data,int len);
 int channel_send_eof(CHANNEL *channel);
 int channel_is_eof(CHANNEL *channel);
-int channel_read(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr);
+int channel_read_nf(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr);
+int channel_read(CHANNEL *channel, BUFFER *buffer,int bytes,int is_stderr,
+		 ssh_cleanup_frame **frames);
 int channel_poll(CHANNEL *channel, int is_stderr);
 int channel_close(CHANNEL *channel);
 int channel_read_nonblocking(CHANNEL *channel, char *dest, int len, int is_stderr);
@@ -288,6 +300,7 @@
 void ssh_options_allow_ssh2(SSH_OPTIONS *opt, int allow);
 void ssh_options_set_dsa_server_key(SSH_OPTIONS *opt, const char *dsakey);
 void ssh_options_set_rsa_server_key(SSH_OPTIONS *opt, const char *rsakey);
+void ssh_options_set_banner(SSH_OPTIONS *opt, const char *banner);
 void ssh_options_set_log_function(SSH_OPTIONS *opt,
     void (*callback)(const char *message, SSH_SESSION *session, int verbosity ));
 void ssh_options_set_log_verbosity(SSH_OPTIONS *opt, int verbosity);
@@ -325,8 +338,9 @@
 int ssh_userauth_none(SSH_SESSION *session, const char *username);
 int ssh_userauth_password(SSH_SESSION *session, const char *username, const char *password);
 int ssh_userauth_offer_pubkey(SSH_SESSION *session, const char *username, int type, STRING *publickey);
-int ssh_userauth_pubkey(SSH_SESSION *session, const char *username, STRING *publickey, PRIVATE_KEY *privatekey);
-int ssh_userauth_autopubkey(SSH_SESSION *session, const char *passphrase);
+  int ssh_userauth_pubkey(SSH_SESSION *session, const char *username, STRING *publickey, PRIVATE_KEY *privatekey);
+int ssh_userauth_autopubkey(SSH_SESSION *session, const char *passphrase, 
+			    ssh_cleanup_frame **frames);
 int ssh_userauth_kbdint(SSH_SESSION *session, const char *user, const char *submethods);
 int ssh_userauth_kbdint_getnprompts(SSH_SESSION *session);
 char *ssh_userauth_kbdint_getname(SSH_SESSION *session);
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/include/libssh/priv.h libssh-wfs/include/libssh/priv.h
--- libssh-trunk/include/libssh/priv.h	2009-07-18 11:02:19.000000000 -0400
+++ libssh-wfs/include/libssh/priv.h	2009-07-07 22:35:57.000000000 -0400
@@ -25,9 +25,12 @@
 
 #ifndef _LIBSSH_PRIV_H
 #define _LIBSSH_PRIV_H
+#include <pthread.h>
 #include "config.h"
 #include "libssh/libssh.h"
 
+#include <assert.h>
+
 /* Debugging constants */
 
 /* Define this if you want to debug crypto systems */
@@ -35,16 +38,25 @@
 /*#define DEBUG_CRYPTO */
 
 /* some constants */
-#define MAX_PACKET_LEN 262144
+// xavid: hack because we send packets that are too big?
+//        there should be an option to allow larger packets
+//        that WheelFS should use
+#define MAX_PACKET_LEN 10*1024*1024
+//#define MAX_PACKET_LEN INT_MAX
+//#define MAX_PACKET_LEN 262144
 #define ERROR_BUFFERLEN 1024
 #define CLIENTBANNER1 "SSH-1.5-" LIBSSH_VERSION
 #define CLIENTBANNER2 "SSH-2.0-" LIBSSH_VERSION
 #define KBDINT_MAX_PROMPT 256 /* more than openssh's :) */
 /* some types for public keys */
+#define TYPE_UNKNOWN 0
 #define TYPE_DSS 1
 #define TYPE_RSA 2
 #define TYPE_RSA1 3
 
+#define PHASE_PUBLICKEY_START 0
+#define PHASE_PUBLICKEY_SIGNATURE 1
+
 /* profiling constants. Don't touch them unless you know what you do */
 #ifdef HAVE_LIBCRYPTO
 #define OPENSSL_BIGNUMS
@@ -350,6 +362,12 @@
     struct ssh_message *ssh_message; /* ssh message */
     int log_verbosity; /*cached copy of the option structure */
     int log_indent; /* indentation level in enter_function logs */
+
+  pthread_mutex_t packet_mutex;
+  pthread_mutex_t crypt_mutex;
+  pthread_mutex_t write_mutex;
+  pthread_mutex_t signal_mutex;
+  pthread_cond_t signal_cond;
 };
 
 struct ssh_kbdint {
@@ -375,6 +393,11 @@
     char *username;
     int method;
     char *password;
+    STRING *publickey;
+    int type; // Algorithm for public key authentication
+    int phase; // Phase of authentication
+    int validated; // 1 if validated, 0 otherwise
+    char *signature;
 };
 
 struct ssh_channel_request_open {
@@ -637,6 +660,45 @@
 #define enter_function() _enter_function(session)
 #define leave_function() _leave_function(session)
 
+// horrible hacks to allow the app to specify cancellation handlers, since
+// things often get canceled in connect
+#define ssh_add_frame(l)			  \
+  if(frames[i] == NULL) goto l; \
+  pthread_cleanup_push( frames[i]->handler, frames[i]->arg ); \
+  i++;
+
+#define ssh_del_frame(l)			  \
+  if(frames[i] == NULL) goto l; \
+  pthread_cleanup_pop(0); \
+  i++;
+
+  // can't loop because cleanup must be in same scope as code
+#define ssh_add_all_frames(l)					\
+  int i = 0;							\
+  ssh_add_frame(l);						\
+  ssh_add_frame(l);						\
+  ssh_add_frame(l);						\
+  ssh_add_frame(l);						\
+  ssh_add_frame(l);						\
+  ssh_add_frame(l);
+
+  // can't loop because cleanup must be in same scope as code
+#define ssh_del_all_frames(l)					\
+  i = 0;							\
+  ssh_del_frame(l);						\
+  ssh_del_frame(l);						\
+  ssh_del_frame(l);						\
+  ssh_del_frame(l);						\
+  ssh_del_frame(l);						\
+  ssh_del_frame(l);
+
+typedef struct _ssh_mem_list {
+  void *ptr;
+  struct _ssh_mem_list *next;
+} ssh_mem_list;
+ssh_mem_list *new_ssh_mem_list();
+void ssh_cleanup_mem(void *);
+
 /** Zero a structure */
 #define ZERO_STRUCT(x) memset((char *)&(x), 0, sizeof(x))
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/include/libssh/server.h libssh-wfs/include/libssh/server.h
--- libssh-trunk/include/libssh/server.h	2009-07-18 11:02:19.000000000 -0400
+++ libssh-wfs/include/libssh/server.h	2009-03-29 15:05:12.000000000 -0400
@@ -72,7 +72,12 @@
 
 char *ssh_message_auth_user(SSH_MESSAGE *msg);
 char *ssh_message_auth_password(SSH_MESSAGE *msg);
+char *ssh_message_auth_publickey(SSH_MESSAGE *msg);
+int ssh_message_auth_phase(SSH_MESSAGE *msg);
+int ssh_message_auth_validated(SSH_MESSAGE *msg);
+
 int ssh_message_auth_reply_success(SSH_MESSAGE *msg,int partial);
+int ssh_message_auth_reply_request_signature(SSH_MESSAGE *msg);
 void ssh_message_auth_set_methods(SSH_MESSAGE *msg, int methods);
 
 CHANNEL *ssh_message_channel_request_open_reply_accept(SSH_MESSAGE *msg);
@@ -83,4 +88,6 @@
 char *ssh_message_channel_request_subsystem(SSH_MESSAGE *msg);
 int ssh_message_channel_request_reply_success(SSH_MESSAGE *msg);
 
+void ssh_send_issue_banner(SSH_SESSION *session, const char *banner);
+
 #endif
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/auth1.c libssh-wfs/libssh/auth1.c
--- libssh-trunk/libssh/auth1.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/auth1.c	2009-07-07 22:35:57.000000000 -0400
@@ -33,30 +33,50 @@
 #ifdef HAVE_SSH1
 static int wait_auth1_status(SSH_SESSION *session){
     /* wait for a packet */
+  int ret = SSH_AUTH_ERROR;
+  int failed = pthread_mutex_lock(&session->packet_mutex);
+  assert(!failed);
+  pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+
     if(packet_read(session))
-        return SSH_AUTH_ERROR;
-    if(packet_translate(session))
-        return SSH_AUTH_ERROR;
-    switch(session->in_packet.type){
+        ret = SSH_AUTH_ERROR;
+    else if(packet_translate(session))
+        ret = SSH_AUTH_ERROR;
+    else switch(session->in_packet.type){
         case SSH_SMSG_SUCCESS:
-            return SSH_AUTH_SUCCESS;
+            ret = SSH_AUTH_SUCCESS;
+	    break;
         case SSH_SMSG_FAILURE:
-            return SSH_AUTH_DENIED;
+            ret = SSH_AUTH_DENIED;
     }
-    ssh_set_error(session,SSH_FATAL,"Was waiting for a SUCCESS or "
-    "FAILURE, got %d",session->in_packet.type);
-    return SSH_AUTH_ERROR;
+
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+
+    if(ret == SSH_AUTH_ERROR) {
+      ssh_set_error(session,SSH_FATAL,"Was waiting for a SUCCESS or "
+		    "FAILURE, got %d",session->in_packet.type);
+    }
+    return ret;
 }
 static int send_username(SSH_SESSION *session, char *username){
     STRING *user;
     /* returns SSH_AUTH_SUCCESS or SSH_AUTH_DENIED */
     if(session->auth_service_asked)
         return session->auth_service_asked;
+    int ret = SSH_AUTH_ERROR;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_USER);
+    bool x = false;
     if(!username)
         if(!(username=session->options->username)){
             if(ssh_options_default_username(session->options))
-                return session->auth_service_asked=SSH_AUTH_ERROR;
+	      x = true;
+	      goto cleanup;
             else
                 username=session->options->username;
         }
@@ -64,8 +84,17 @@
     buffer_add_ssh_string(session->out_buffer,user);
     free(user);
     packet_send(session);
+
+ cleanup:
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(x) goto exit;
+
     session->auth_service_asked=wait_auth1_status(session);
-    return session->auth_service_asked;
+    ret=session->auth_service_asked;
+ exit:
+    return ret;
 }
 
 /* use the "none" authentication question */
@@ -194,11 +223,18 @@
         strcpy((char *)password_s->string,password);
     }
 
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_AUTH_PASSWORD);
     buffer_add_ssh_string(session->out_buffer,password_s);
     string_burn(password_s);
     free(password_s);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     return wait_auth1_status(session);
 }
 
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/auth.c libssh-wfs/libssh/auth.c
--- libssh-trunk/libssh/auth.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/auth.c	2009-07-18 10:58:14.000000000 -0400
@@ -57,6 +57,10 @@
     int todo = 0;
     char *auth_methods = NULL;
     enter_function();
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+
     while(cont){
         if(packet_read(session))
             break;
@@ -68,8 +72,8 @@
                 if(!auth || buffer_get_u8(session->in_buffer,&partial)!=1 ){
                     ssh_set_error(session,SSH_FATAL,
                             "invalid SSH_MSG_USERAUTH_FAILURE message");
-                    leave_function();
-                    return SSH_AUTH_ERROR;
+                    err = SSH_AUTH_ERROR;
+		    goto exit;
                 }
                 auth_methods = string_to_char(auth);
                 if(partial) {
@@ -132,6 +136,13 @@
                 break;
         }
     }
+
+ exit:
+    ;
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+
     leave_function();
     return err;
 }
@@ -189,6 +200,10 @@
     user=string_from_char(username);
     method=string_from_char("none");
     service=string_from_char("ssh-connection");
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_REQUEST);
     buffer_add_ssh_string(session->out_buffer,user);
     buffer_add_ssh_string(session->out_buffer,service);
@@ -197,6 +212,9 @@
     free(method);
     free(user);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     ret = wait_auth_status(session,0);
     leave_function();
     return ret;
@@ -247,7 +265,10 @@
     service=string_from_char("ssh-connection");
     method=string_from_char("publickey");
     algo=string_from_char(ssh_type_to_char(type));
-
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_REQUEST);
     buffer_add_ssh_string(session->out_buffer,user);
     buffer_add_ssh_string(session->out_buffer,service);
@@ -255,12 +276,18 @@
     buffer_add_u8(session->out_buffer,0);
     buffer_add_ssh_string(session->out_buffer,algo);
     buffer_add_ssh_string(session->out_buffer,publickey);
-    packet_send(session);
-    err=wait_auth_status(session,0);
+
     free(user);
     free(method);
     free(service);
     free(algo);
+    packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+
+    err=wait_auth_status(session,0);
+
     leave_function();
     return err;
 }
@@ -300,6 +327,7 @@
             } else
                 username=session->options->username;
         }
+
     if(ask_userauth(session)){
         leave_function();
     	return err;
@@ -309,8 +337,11 @@
     method=string_from_char("publickey");
     algo=string_from_char(ssh_type_to_char(privatekey->type));
 
-
     /* we said previously the public key was accepted */
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_REQUEST);
     buffer_add_ssh_string(session->out_buffer,user);
     buffer_add_ssh_string(session->out_buffer,service);
@@ -319,16 +350,23 @@
     buffer_add_ssh_string(session->out_buffer,algo);
     buffer_add_ssh_string(session->out_buffer,publickey);
     sign=ssh_do_sign(session,session->out_buffer,privatekey);
-    if(sign){
-        buffer_add_ssh_string(session->out_buffer,sign);
-        free(sign);
-        packet_send(session);
-        err=wait_auth_status(session,0);
-    }
+
     free(user);
     free(service);
     free(method);
     free(algo);
+
+    if(sign){
+        buffer_add_ssh_string(session->out_buffer,sign);
+        free(sign); 
+
+	packet_send(session);
+        err=wait_auth_status(session,0);
+    }
+
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     leave_function();
     return err;
 }
@@ -378,6 +416,10 @@
     method=string_from_char("password");
     password_s=string_from_char(password);
 
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_REQUEST);
     buffer_add_ssh_string(session->out_buffer,user);
     buffer_add_ssh_string(session->out_buffer,service);
@@ -390,6 +432,9 @@
     memset(password_s,0,strlen(password)+4);
     free(password_s);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
     err=wait_auth_status(session,0);
     leave_function();
     return err;
@@ -417,7 +462,12 @@
  * \see ssh_options_set_identity()
  */
 
-int ssh_userauth_autopubkey(SSH_SESSION *session, const char *passphrase) {
+void ssh_private_key_cleanup(void *arg) {
+  private_key_free( (PRIVATE_KEY *) arg );
+}
+
+int ssh_userauth_autopubkey(SSH_SESSION *session, const char *passphrase, 
+			    ssh_cleanup_frame **frames) {
     int count=1; /* bypass identity */
     int type=0;
     int err;
@@ -426,23 +476,42 @@
     PRIVATE_KEY *privkey;
     char *id=NULL;
     enter_function();
+
+    int ret = SSH_AUTH_DENIED;
+    // can't loop because cleanup must be in same scope as code
+    ssh_add_all_frames(add1);
+ add1:
+
+    ;// why?
+    ssh_mem_list *id_node = new_ssh_mem_list();
+    ssh_mem_list *pubkey_node = new_ssh_mem_list();
+    id_node->next = pubkey_node;
+    ssh_mem_list *pkf_node = new_ssh_mem_list();
+    pubkey_node->next = pkf_node;
+    pthread_cleanup_push( &ssh_cleanup_mem, id_node );
+
     // always testing none
     err=ssh_userauth_none(session,NULL);
     if(err==SSH_AUTH_ERROR || err==SSH_AUTH_SUCCESS){
-    	leave_function();
-        return err;
+      ret=err;
+      goto exit;
     }
     if(session->options->identity){
         ssh_say(2,"Trying identity file %s\n",session->options->identity);
         keys_path[0]=session->options->identity;
         /* let's hope alloca exists */
         id=malloc(strlen(session->options->identity)+1 + 4);
+	id_node->ptr = id;
         sprintf(id,"%s.pub",session->options->identity);
         pub_keys_path[0]=id;
         count =0;
     }
     while((pubkey=publickey_from_next_file(session,pub_keys_path,keys_path, &privkeyfile,&type,&count))){
+
+        pkf_node->ptr = privkeyfile;
+	pubkey_node->ptr = pubkey;
         err=ssh_userauth_offer_pubkey(session,NULL,type,pubkey);
+
         if(err==SSH_AUTH_ERROR){
             if(id){
                 pub_keys_path[0]=NULL;
@@ -451,8 +520,8 @@
             }
             free(pubkey);
             free(privkeyfile);
-            leave_function();
-            return err;
+	    ret = err;
+	    goto exit;
         } else
         if(err != SSH_AUTH_SUCCESS){
             ssh_say(2,"Public key refused by server\n");
@@ -460,8 +529,11 @@
             pubkey=NULL;
             free(privkeyfile);
             privkeyfile=NULL;
+	    pubkey_node->ptr=NULL;
+	    pkf_node->ptr=NULL;
             continue;
         }
+	ssh_say(2,"Public key accepted by server!\n");
         /* pubkey accepted by server ! */
         privkey=privatekey_from_file(session,privkeyfile,type,passphrase);
         if(!privkey){
@@ -470,42 +542,52 @@
             pubkey=NULL;
             free(privkeyfile);
             privkeyfile=NULL;
+	    pubkey_node->ptr=NULL;
+	    pkf_node->ptr=NULL;
             continue; /* continue the loop with other pubkey */
         }
+	pthread_cleanup_push( &ssh_private_key_cleanup, privkey );
         err=ssh_userauth_pubkey(session,NULL,pubkey,privkey);
+	ssh_say(2,"Got %d when authing Public key...\n",err);
         if(err==SSH_AUTH_ERROR){
             if(id){
                 pub_keys_path[0]=NULL;
                 keys_path[0]=NULL;
                 free(id);
             }
-            free(pubkey);
-            free(privkeyfile);
-            private_key_free(privkey);
-            leave_function();
-            return err;
+	    ret = err;
+	    goto inner_exit;
         } else
         if(err != SSH_AUTH_SUCCESS){
             ssh_say(0,"Weird : server accepted our public key but refused the signature\nit might be a bug of libssh\n");
-            free(pubkey);
-            pubkey=NULL;
-            free(privkeyfile);
-            privkeyfile=NULL;
-            private_key_free(privkey);
-            continue;
+	    goto inner_exit;
         }
         /* auth success */
         ssh_say(1,"Authentication using %s success\n",privkeyfile);
+    inner_exit:
+	;
+	pthread_cleanup_pop(0);
         free(pubkey);
+	pubkey=NULL;
         private_key_free(privkey);
         free(privkeyfile);
+	privkeyfile=NULL;
+	pubkey_node->ptr=NULL;
+	pkf_node->ptr=NULL;
+	if(err==SSH_AUTH_ERROR){
+	  goto exit;
+        } else
+        if(err != SSH_AUTH_SUCCESS){
+	  continue;
+	}
+
         if(id){
             pub_keys_path[0]=NULL;
             keys_path[0]=NULL;
             free(id);
         }
-        leave_function();
-        return SSH_AUTH_SUCCESS;
+        ret = SSH_AUTH_SUCCESS;
+	goto exit;
     }
     /* at this point, pubkey is NULL and so is privkeyfile */
     ssh_say(1,"Tried every public key, none matched\n");
@@ -515,8 +597,20 @@
         keys_path[0]=NULL;
         free(id);
     }
+
+ exit:
+
+    ; // why?
+    pthread_cleanup_pop(0);
+    free(id_node);
+    free(pubkey_node);
+    free(pkf_node);
+
+    ssh_del_all_frames(del1);
+ del1:
+
     leave_function();
-    return SSH_AUTH_DENIED;
+    return ret;
 }
 
 static struct ssh_kbdint *kbdint_new(){
@@ -594,7 +688,12 @@
     STRING *service=string_from_char("ssh-connection");
     STRING *method=string_from_char("keyboard-interactive");
     int err;
+    int r;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_REQUEST);
     buffer_add_ssh_string(session->out_buffer,user_s);
     buffer_add_ssh_string(session->out_buffer,service);
@@ -605,7 +704,11 @@
     free(service);
     free(method);
     free(submethods_s);
-    if(packet_send(session)){
+    r = packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r){
         leave_function();
     	return SSH_AUTH_ERROR;
     }
@@ -676,7 +779,12 @@
     STRING *answer;
     u32 i;
     int err;
+    int r;
     enter_function();
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH2_MSG_USERAUTH_INFO_RESPONSE);
     buffer_add_u32(session->out_buffer,htonl(session->kbdint->nprompts));
     for(i=0;i<session->kbdint->nprompts;++i){
@@ -688,7 +796,11 @@
         string_burn(answer);
         free(answer);
     }
-    if(packet_send(session)){
+    r = packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r){
         leave_function();
     	return SSH_AUTH_ERROR;
     }
diff -Naur --exclude 'autom4te*' --exclude aclocal.m4 --exclude debian --exclude 'config*' --exclude '.*' --exclude CVS --exclude stamp-h1 --exclude Makefile --exclude Makefile.in --exclude libtool --exclude lib.bat --exclude 'Doxyfile*' --exclude Makefile.Windows libssh-trunk/libssh/channels1.c libssh-wfs/libssh/channels1.c
--- libssh-trunk/libssh/channels1.c	2009-07-18 11:02:26.000000000 -0400
+++ libssh-wfs/libssh/channels1.c	2009-07-07 22:35:57.000000000 -0400
@@ -65,7 +65,12 @@
 int channel_request_pty_size1(CHANNEL *channel, char *terminal, int col,
         int row){
     STRING *str;
+    int ret;
     SSH_SESSION *session=channel->session;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     str=string_from_char(terminal);
     buffer_add_u8(session->out_buffer,SSH_CMSG_REQUEST_PTY);
     buffer_add_ssh_string(session->out_buffer,str);
@@ -76,16 +81,26 @@
     buffer_add_u32(session->out_buffer,0); /* y */
     buffer_add_u8(session->out_buffer,0); /* tty things */
     ssh_say(2,"Opening a ssh1 pty\n");
-    if(packet_send(session))
-        return -1;
+    ret=packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(ret)
+      return -1;
+
+    ret = -1;
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+
     if(packet_read(session))
-        return -1;
+      goto exit;
     if(packet_translate(session))
-        return -1;
+      goto exit;
     switch (session->in_packet.type){
         case SSH_SMSG_SUCCESS:
             ssh_say(2,"pty : Success\n");
-            return 0;
+	    ret = 0;
             break;
         case SSH_SMSG_FAILURE:
             ssh_set_error(session,SSH_REQUEST_DENIED,
@@ -97,22 +112,40 @@
             ssh_set_error(session,SSH_FATAL,
                     "Received unexpected packet type %d",
                     session->in_packet.type);
-            return -1;
     }
-    return -1;
+ exit:
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->packet_mutex);
+    assert(!failed);
+    return ret;
 }
 
 int channel_change_pty_size1(CHANNEL *channel, int cols, int rows){
     SSH_SESSION *session=channel->session;
+    int r;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_WINDOW_SIZE);
     buffer_add_u32(session->out_buffer,ntohl(rows));
     buffer_add_u32(session->out_buffer,ntohl(cols));
     buffer_add_u32(session->out_buffer,0);
     buffer_add_u32(session->out_buffer,0);
-    if(packet_send(session))
+    r = packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r)
         return -1;
+
     ssh_say(2,"Change pty size send\n");
+    int failed = pthread_mutex_lock(&session->packet_mutex);
+    pthread_cleanup_push(&ssh_cleanup_lock, (void *) &session->packet_mutex);
+    assert (!failed);
     packet_wait(session,SSH_SMSG_SUCCESS,1);
+    pthread_cleanup_pop(0);
+    pthread_mutex_unlock(&session->packet_mutex);
     switch (session->in_packet.type){
         case SSH_SMSG_SUCCESS:
             ssh_say(2,"pty size changed\n");
@@ -130,9 +163,20 @@
 
 int channel_request_shell1(CHANNEL *channel){
     SSH_SESSION *session=channel->session;
+    int r;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_EXEC_SHELL);
-    if(packet_send(session))
-        return -1;
+    r=packet_send(session);
+
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r)
+      return -1;
+
     ssh_say(2,"Launched a shell\n");
     return 0;
 }
@@ -140,11 +184,20 @@
 int channel_request_exec1(CHANNEL *channel, char *cmd){
     SSH_SESSION *session=channel->session;
     STRING *command=string_from_char(cmd);
+    int r;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_EXEC_CMD);
     buffer_add_ssh_string(session->out_buffer,command);
     free(command);
-    if(packet_send(session))
-        return -1;
+    r=packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    if(r)
+      return -1;
     ssh_say(2,"executing %s...\n",cmd);
     return 0;
 }
@@ -175,8 +228,15 @@
     /* actually status is lost somewhere */
     channel->open=0;
     channel->remote_eof=1;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     buffer_add_u8(session->out_buffer,SSH_CMSG_EXIT_CONFIRMATION);
     packet_send(session);
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
 }
 
 void channel_handle1(SSH_SESSION *session, int type){
@@ -196,8 +256,13 @@
 
 int channel_write1(CHANNEL *channel, void *data, int len){
     SSH_SESSION *session=channel->session;
+    int ret;
     int origlen=len;
     int effectivelen;
+    int failed = pthread_mutex_lock(&session->write_mutex);
+    assert(!failed);
+    pthread_cleanup_push(&ssh_cleanup_lock,
+			 (void *) &session->write_mutex);
     while(len>0){
         buffer_add_u8(session->out_buffer,SSH_CMSG_STDIN_DATA);
         if(len > 32000)
@@ -208,10 +273,18 @@
         buffer_add_data(session->out_buffer,data,effectivelen);
         data+=effectivelen;
         len-=effectivelen;
-        if(packet_send(session))
-            return -1;
+        if(packet_send(session)) {
+	  ret=-1;
+	  goto exit;
+	}
     }
-    return origlen;
+    ret=origlen;
+ exit:
+    ;
+    pthread_cleanup_pop(0);
+    failed = pthread_mutex_unlock(&session->write_mutex);
+    assert(!failed);
+    return ret;
 }
 
 #endif /* HAVE_SSH1 */
